/*
 * iphula.h
 *
 *
 * Part of (p)IPHULA 1.16 (May 2007)
 *
 * (c) 2004-2007 by Heiko A. Schmidt, Jutta Buschbom, 
 *                  Gunter Weiss, and Arndt von Haeseler
 * (c) 1998-2004 by Gunter Weiss and Arndt von Haeseler
 *
 * All parts of the source except where indicated are distributed 
 * under the GNU public licence 2. 
 * See http://www.opensource.org/licenses/gpl-license.php details.
 *
 * ($Id: iphula.h,v 1.5 2005/09/29 13:29:57 hschmidt Exp $)
 *
 */

#ifndef IPHULA_H
#define IPHULA_H

#define STDERR stderr
#define STDOUT stdout

#define TRUE 1
#define FALSE 0

#  define FILENAMELENGTH 2048

EXTERN char infilename         [FILENAMELENGTH];
EXTERN char fileprefixname     [FILENAMELENGTH];
EXTERN char panelfilename      [FILENAMELENGTH];
EXTERN char matrixfilename     [FILENAMELENGTH];
EXTERN char paramsfilename     [FILENAMELENGTH];
EXTERN char rawfilename        [FILENAMELENGTH];

#define INFILENAME     infilename
#define MATRIXFILEEXT  "matrix"
#define MATRIXFILE     matrixfilename
#define PARAMSFILEEXT  "params"
#define PARAMSFILE     paramsfilename
#define PANELFILEEXT   "iphula"
#define PANELFILE      panelfilename
#define RAWFILEEXT     "raw"
#define RAWFILE        rawfilename
#define PREFIXDEFAULT  "panel"
#define FILEPREFIX     fileprefixname

EXTERN char formatstring       [FILENAMELENGTH];
#define FORMAT         formatstring
EXTERN char simnumformatstring       [FILENAMELENGTH];
#define SIMNUMFORMAT         simnumformatstring

EXTERN int setprefix_optn;   /* use other FILEPREFIX that INFILENAME */

/* setprefix_optn values  (xxx) */
#define SETPREFIX_NONE   0
#define SETPREFIX_PREFIX 1

EXTERN int setinfile_optn;   /* use other FILEINFILE that INFILENAME */

/* setinfile_optn values  (xxx) */
#define SETINFILE_NONE   0
#define SETINFILE_INFILE 1

EXTERN int writeraw_optn;   /* write raw simulation data to *.raw file */

#endif /* IPHULA_H */
