/*
 * mpiiphula.h
 *
 *
 * Part of (p)IPHULA 1.16 (May 2007)
 *
 * (c) 2004-2007 by Heiko A. Schmidt, Jutta Buschbom, 
 *                  Gunter Weiss, and Arndt von Haeseler
 * (c) 1998-2004 by Gunter Weiss and Arndt von Haeseler
 *
 * All parts of the source except where indicated are distributed 
 * under the GNU public licence 2. 
 * See http://www.opensource.org/licenses/gpl-license.php details.
 *
 * ($Id: mpiiphula.h,v 1.3 2005/09/30 11:01:03 hschmidt Exp $)
 *
 */


#ifndef _MPIIPHULA_
#define _MPIIPHULA_

#include "sub1.h"

extern int PI_IamSlave;
extern int PI_IamMaster;

#ifdef USE_MPI
#    include <mpi.h>
#    include "sched.h"
#endif

#if USE_MPI
                                   /* Scheduling algorithms for: */
#  define SCHEDALG_PUZZLING   sgss /* puzzling step              */

#  define PI_DONE                0 /* Finished            M->S */
#  define PI_PARAMS              1 /* Parameters needed   M->S */
#  define PI_DOSIMUL             2 /* Simulation Specs    M->S */
#  define PI_SIMULRESULTS        3 /* Simulation Results  S->M */

   extern int      PI_IamMaster;
   extern int      PI_IamSlave;
   extern int      PI_Myid;
   extern int      PI_MyMaster;
   extern int      PI_NumProcs;
   extern MPI_Comm PI_Comm;
#endif /* USE_MPI */

#ifndef uli
#  define uli unsigned long int
#endif

extern uli *simulsent;
extern uli *simulrecved;
extern uli *dosimulsent;
extern uli *dosimulrecved;
extern uli *simulsentn;
extern uli *simulrecvedn;
extern uli *dosimulsentn;
extern uli *dosimulrecvedn;

extern uli PI_simulsent;
extern uli PI_simulrecved;
extern uli PI_dosimulsent;
extern uli PI_dosimulrecved;
extern uli PI_simulsentn;
extern uli PI_simulrecvedn;
extern uli PI_dosimulsentn;
extern uli PI_dosimulrecvedn;

void PI_SendDone(void);
void PI_RecvDone(void);

int  PI_emptyslave(void);
void PI_putslave(int sl);
int  PI_getslave(void);

#endif /* _MPIIPHULA_ */
