/*
 * sub2.h
 *
 *
 * Part of (p)IPHULA 1.16 (May 2007)
 *
 * (c) 2004-2007 by Heiko A. Schmidt, Jutta Buschbom, 
 *                  Gunter Weiss, and Arndt von Haeseler
 * (c) 1998-2004 by Gunter Weiss and Arndt von Haeseler
 *
 * All parts of the source except where indicated are distributed 
 * under the GNU public licence 2. 
 * See http://www.opensource.org/licenses/gpl-license.php details.
 *
 * ($Id: sub2.h,v 1.6 2005/09/29 13:29:57 hschmidt Exp $)
 *
 */


#ifndef SUB2_H
#define SUB2_H

#include "tree.h"

#define MAX_RATE_CATS 32

extern int numTaxa, NumBases;

extern double GammaShape;
extern int NumCats;
extern double CatRate[MAX_RATE_CATS];
extern double freqRate[MAX_RATE_CATS];

extern short *Categories;

/* extern double *observed; */	/* not really used - delete? (HAS) */
#define OBS_NUMVARPOS  0
#define OBS_MEANPWDIST 1

extern TTree *tree;
extern int NumVarPos;
extern double MeanPWDist;
extern double ***prob_com;
extern double tolerance;
extern double thetaScale;

extern FILE *outseq;

extern double Freq[4], CumulFreq[4];
extern double ksi, kappa;
extern double freqR, freqY, freqAG, freqCT;
extern double freqA, freqC, freqG, freqT;

void SetModel(void);
void SetMatrix(double *matrix, double len);
void SetVector(double *vector, short base, double len);

void *CAllocMem(long n);

void SetCategories(int NumCats, short *Categories); /* (HAS) */
void CreateSequences(TTree *tree);
void EvolveSequences(TTree *tree, double scale);
/* void Stats(TTree *tree); */
void Stats(TTree *tree, int *obs_numvarpos, double *obs_meanpwdist);


/* void seq_gen(TTree *tree, int d, int f, int tt, double theta0); */
/* void seq_gen(TTree *tree, int d, int f, int tt, double theta0, unsigned long int *count_positive, FILE *raw_fp); */
void seq_gen(TTree *tree, double theta0, unsigned long int *count_positive, FILE *raw_fp);

#endif /* SUB2_H */
