/*
 * tree.h
 *
 *
 * Part of (p)IPHULA 1.16 (May 2007)
 *
 * (c) 2004-2007 by Heiko A. Schmidt, Jutta Buschbom, 
 *                  Gunter Weiss, and Arndt von Haeseler
 * (c) 1998-2004 by Gunter Weiss and Arndt von Haeseler
 *
 * All parts of the source except where indicated are distributed 
 * under the GNU public licence 2. 
 * See http://www.opensource.org/licenses/gpl-license.php details.
 *
 * ($Id: tree.h,v 1.2 2005/03/09 02:24:23 hschmidt Exp $)
 *
 */

/*  Header file to define tree and node structures     */

/*  (c) Copyright 1996, Andrew Rambaut                 */
/*  Department of Zoology, University of Oxford        */

#ifndef _TREE_H_
#define _TREE_H_

#define MAX_NAME_LEN 64
#define MAX_TIPS 1000

typedef struct TNode TNode;
struct TNode {
	TNode *branch0, *branch1, *branch2, *next;
	double length0, length1, length2, param;
	int tipNo;
	
	char *sequence;
};


typedef struct TTree TTree;
struct TTree {
	int rooted, lengths;
	TNode *root, *nodeList;
	int numTips, numNodes;
	double totalLength;
	char *names[MAX_TIPS];
	TNode *tips[MAX_TIPS];
};

#endif /* _TREE_H_ */

